var ExtractionReg = function()
{
	var exreg = {};
	var debug = 0;
	
	var reagentFileIsValid = false;
	var consumablesFileIsValid = false;
	var jsonConsumables = {};
	
	// Page initialization
	exreg.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', exreg.validateStep1);
		Events.addEventHandler('consumablesFile', 'change', exreg.consumablesFileOnChange);
		Events.addEventHandler('expirationDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('expirationDate', 'blur', exreg.expirationDateOnChange);

		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', exreg.initializeStep2);
/*
		Events.addEventHandler('step-2', 'wizard-validate', exreg.validateStep2);
*/

		Buttons.addClickHandler('downloadReagentLotNoFile', exreg.downloadReagentLotNoFile);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
/*
		Buttons.addClickHandler('gocreate', exreg.createProtocol);
*/
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', exreg.submit);

		exreg.initializeStep1();
	}

	exreg.initializeStep1 = function()
	{
		var frm = document.forms['meludi'];

		Wizard.setCurrentStep(1);
		Doc.show('step-1');
		Doc.show('gonext');
	}

	exreg.validateStep1 = function(event)
	{
		var frm = document.forms['meludi'];
//alert("exreg.validateStep1(): consumablesFileIsValid = " + consumablesFileIsValid);
		if (!consumablesFileIsValid)
		{
			event.preventDefault();
		}
		else
		{
			Wizard.setInputStatus('consumablesFile', 'valid');
		}
	}
	
	exreg.consumablesFileOnChange = function()
	{
		var frm = document.forms['meludi'];
		var file = frm.consumablesFile.files[0];
		
		var reader = new FileReader();
		reader.onload = exreg.consumablesFileLoaded;
		reader.readAsText(file);
	}

	exreg.consumablesFileLoaded = function(event)
	{
		exreg.parseConsumablesFile(event.target.result);
	}

	exreg.parseConsumablesFile = function(data)
	{
		var frm = document.forms['meludi'];
		var expirationDate = frm.expirationDate.value;

		consumablesFileIsValid = false;

		// Column data are stored in JSONArrays
		var jsonHeaders = [];
		var jsonKitName = [];
		var jsonLibraryPrepBox1 = [];
		var jsonIndexKit = [];
		var jsonContentSetBox3 = [];
		var jsonOligoPoolA_FPA = [];
		var jsonOligoPoolB_FPB = [];
		var jsonOligoHybridizationSequencingReagent3 = [];
		var jsonStringentWash1_SW1 = [];
		var jsonExtensionLigationMix3 = [];
		var jsonPcrMasterMix2_PMM2 = [];
		var jsonUB1 = [];
		var jsonTDP = [];
		var jsonFilterplate = [];
		
		var jsonIndexPrimerA701 = [];
		var jsonIndexPrimerA702 = [];
		var jsonIndexPrimerA703 = [];
		var jsonIndexPrimerA704 = [];
		var jsonIndexPrimerA705 = [];
		var jsonIndexPrimerA706 = [];
		var jsonIndexPrimerA707 = [];
		var jsonIndexPrimerA708 = [];
		var jsonIndexPrimerA709 = [];
		var jsonIndexPrimerA710 = [];
		var jsonIndexPrimerA711 = [];
		var jsonIndexPrimerA712 = [];
		
		var jsonIndexPrimerA501 = [];
		var jsonIndexPrimerA502 = [];
		var jsonIndexPrimerA503 = [];
		var jsonIndexPrimerA504 = [];
		var jsonIndexPrimerA505 = [];
		var jsonIndexPrimerA506 = [];
		var jsonIndexPrimerA507 = [];
		var jsonIndexPrimerA508 = [];

		var jsonExpirationDate = [];

		// Find column separator as first character after first occurrence of search string
		var separator = ExtractUtils.findSeparator(data, "Consumables");
		if (separator == null)
		{
			// Comma is default separator
			separator = ',';
		}
//alert("add_consumables_lot_number_file.js::parseConsumablesFile(): separator = \"" + separator + "\"");
		var columnSplitRegexp = new RegExp(" *" + separator + " *",'');
		var lines = data.split(/[\n\r]+/);
//alert("add_consumables_lot_number_file.js::parseConsumablesFile(): lines.length = " + lines.length);
		//var columns = lines[0].split(columnSplitRegexp);

		var numImported = 0;
		for (var i = 1; i < lines.length; i++)
		{
			if (lines[i].match(/^\s*$/)) continue; // Ignore empty lines
			var columns = lines[i].split(columnSplitRegexp);
//alert("add_consumables_lot_number_file.js::parseConsumablesFile(): i = " + i + " columns[0] = " + columns[0] + " columns[1] = " + columns[1]);
			// First column is either empty, or equal to barcode sequence for index primers
			header = columns[1];
			firstDataIndex = 2;
			// Skip lines without data
			if (header != '')
			{
				jsonHeaders[jsonHeaders.length] = header;

				for (var j = 0; j < (columns.length - firstDataIndex); j++)
				{
					var data = columns[firstDataIndex + j];
					if (header == 'TruSight Tumor Library Preparation partI')
					{
						jsonKitName[j] = data;
					}
					else if (header == 'TruSight Tumor Library Prep Box 1')
					{
						jsonLibraryPrepBox1[j] = data;
					}
					else if (header == 'TruSight Tumor Index Kit')
					{
						jsonIndexKit[j] = data;
					}
					else if (header == 'TruSight Tumor Content Set Box 3')
					{
						jsonContentSetBox3[j] = data;
					}
					else if (header == 'TruSight Tumor Oligo Pool A (FPA)')
					{
						jsonOligoPoolA_FPA[j] = data;
					}
					else if (header == 'TruSight Tumor Oligo Pool B (FPB)')
					{
						jsonOligoPoolB_FPB[j] = data;
					}
					else if (header == 'Oligo Hybridization for Sequencing Reagent 3 (OHS3)')
					{
						jsonOligoHybridizationSequencingReagent3[j] = data;
					}
					else if (header == 'Stringent Wash 1 (SW1)')
					{
						jsonStringentWash1_SW1[j] = data;
					}
					else if (header == 'Extension Ligation Mix 3 (ELM3)')
					{
						jsonExtensionLigationMix3[j] = data;
					}
					else if (header == 'PCR Master Mix 2 (PMM2)')
					{
						jsonPcrMasterMix2_PMM2[j] = data;
					}
					else if (header == 'UB1')
					{
						jsonUB1[j] = data;
					}
					else if (header == 'TDP')
					{
						jsonTDP[j] = data;
					}
					else if (header == 'Filterplate')
					{
						jsonFilterplate[j] = data;
					}
					else if (header == 'Index Primer A701')
					{
						jsonIndexPrimerA701[j] = data;
					}
					else if (header == 'Index Primer A702')
					{
						jsonIndexPrimerA702[j] = data;
					}
					else if (header == 'Index Primer A703')
					{
						jsonIndexPrimerA703[j] = data;
					}
					else if (header == 'Index Primer A704')
					{
						jsonIndexPrimerA704[j] = data;
					}
					else if (header == 'Index Primer A705')
					{
						jsonIndexPrimerA705[j] = data;
					}
					else if (header == 'Index Primer A706')
					{
						jsonIndexPrimerA706[j] = data;
					}
					else if (header == 'Index Primer A707')
					{
						jsonIndexPrimerA707[j] = data;
					}
					else if (header == 'Index Primer A708')
					{
						jsonIndexPrimerA708[j] = data;
					}
					else if (header == 'Index Primer A709')
					{
						jsonIndexPrimerA709[j] = data;
					}
					else if (header == 'Index Primer A710')
					{
						jsonIndexPrimerA710[j] = data;
					}
					else if (header == 'Index Primer A711')
					{
						jsonIndexPrimerA711[j] = data;
					}
					else if (header == 'Index Primer A712')
					{
						jsonIndexPrimerA712[j] = data;
					}
					else if (header == 'Index Primer A501')
					{
						jsonIndexPrimerA501[j] = data;
					}
					else if (header == 'Index Primer A502')
					{
						jsonIndexPrimerA502[j] = data;
					}
					else if (header == 'Index Primer A503')
					{
						jsonIndexPrimerA503[j] = data;
					}
					else if (header == 'Index Primer A504')
					{
						jsonIndexPrimerA504[j] = data;
					}
					else if (header == 'Index Primer A505')
					{
						jsonIndexPrimerA505[j] = data;
					}
					else if (header == 'Index Primer A506')
					{
						jsonIndexPrimerA506[j] = data;
					}
					else if (header == 'Index Primer A507')
					{
						jsonIndexPrimerA507[j] = data;
					}
					else if (header == 'Index Primer A508')
					{
						jsonIndexPrimerA508[j] = data;
					}
					// Expiration date is set to same date for all kits in same consumables file
					jsonExpirationDate[j] = expirationDate;
				}
			}
		}
		// Add header for expiration date
		jsonHeaders[jsonHeaders.length] = "Expiration date";

		jsonConsumables['Headers'] = jsonHeaders;

		jsonConsumables['KitName'] = jsonKitName;
		jsonConsumables['LibraryPrepBox1'] = jsonLibraryPrepBox1;
		jsonConsumables['IndexKit'] = jsonIndexKit;
		jsonConsumables['ContentSetBox3'] = jsonContentSetBox3;
		jsonConsumables['OligoPoolA_FPA'] = jsonOligoPoolA_FPA;
		jsonConsumables['OligoPoolB_FPB'] = jsonOligoPoolB_FPB;
		jsonConsumables['OligoHybridizationSequencingReagent3'] = jsonOligoHybridizationSequencingReagent3;
		jsonConsumables['StringentWash1_SW1'] = jsonStringentWash1_SW1;
		jsonConsumables['ExtensionLigationMix3'] = jsonExtensionLigationMix3;
		jsonConsumables['PcrMasterMix2_PMM2'] = jsonPcrMasterMix2_PMM2;
		jsonConsumables['UB1'] = jsonUB1;
		jsonConsumables['TDP'] = jsonTDP;
		jsonConsumables['Filterplate'] = jsonFilterplate;

		jsonConsumables['IndexPrimerA701'] = jsonIndexPrimerA701;
		jsonConsumables['IndexPrimerA702'] = jsonIndexPrimerA702;
		jsonConsumables['IndexPrimerA703'] = jsonIndexPrimerA703;
		jsonConsumables['IndexPrimerA704'] = jsonIndexPrimerA704;
		jsonConsumables['IndexPrimerA705'] = jsonIndexPrimerA705;
		jsonConsumables['IndexPrimerA706'] = jsonIndexPrimerA706;
		jsonConsumables['IndexPrimerA707'] = jsonIndexPrimerA707;
		jsonConsumables['IndexPrimerA708'] = jsonIndexPrimerA708;
		jsonConsumables['IndexPrimerA709'] = jsonIndexPrimerA709;
		jsonConsumables['IndexPrimerA710'] = jsonIndexPrimerA710;
		jsonConsumables['IndexPrimerA711'] = jsonIndexPrimerA711;
		jsonConsumables['IndexPrimerA712'] = jsonIndexPrimerA712;

		jsonConsumables['IndexPrimerA501'] = jsonIndexPrimerA501;
		jsonConsumables['IndexPrimerA502'] = jsonIndexPrimerA502;
		jsonConsumables['IndexPrimerA503'] = jsonIndexPrimerA503;
		jsonConsumables['IndexPrimerA504'] = jsonIndexPrimerA504;
		jsonConsumables['IndexPrimerA505'] = jsonIndexPrimerA505;
		jsonConsumables['IndexPrimerA506'] = jsonIndexPrimerA506;
		jsonConsumables['IndexPrimerA507'] = jsonIndexPrimerA507;
		jsonConsumables['IndexPrimerA508'] = jsonIndexPrimerA508;

		jsonConsumables['ExpirationDate'] = jsonExpirationDate;

		Wizard.setInputStatus('consumablesFile', 'valid');
		consumablesFileIsValid = true;
	}

	exreg.expirationDateOnChange = function()
	{
		var frm = document.forms['meludi'];
		
		var expirationDateIsValid = Wizard.isValid('expirationDate');
		
		if (!expirationDateIsValid) return;

		var expirationDate = frm.expirationDate.value;

		// Update expiration date in jsonConsumables JSONObject, if consumables file already has been loaded
		var jsonExpirationDate = jsonConsumables['ExpirationDate'];
		if (jsonExpirationDate)
		{
			for (var j = 0; j < jsonExpirationDate.length; j++)
			{
				// Expiration date is set to same date for all kits in same consumables file
				jsonExpirationDate[j] = expirationDate;
			}
			jsonConsumables['ExpirationDate'] = jsonExpirationDate;
		}
	}

	exreg.initializeStep2 = function()
	{
		var frm = document.forms['meludi'];
		var consumablesFileName = frm.consumablesFile.value;
		Doc.element('detailsConsumablesFileName').innerHTML = '<b>Consumables file: ' + consumablesFileName + '</b>';
//alert("exreg.initializeStep2(): Start consumablesFile = " + consumablesFileName);
		var html = '<table id="detailsTable" class="step-form">';

		// First header row
		html += '<thead>';
		html += '<tr>';
		html += '<th>TruSight Tumor Library Preparation partI</th>';
		html += '<th class="dottedleft">TruSight Tumor Library Prep Box 1</th>';
		html += '<th class="dottedleft">TruSight Tumor Index Kit</th>';
		html += '<th class="dottedleft">TruSight Tumor Content Set Box 3</th>';
		html += '<th class="dottedleft">TruSight Tumor Oligo Pool A (FPA)</th>';
		html += '<th class="dottedleft">TruSight Tumor Oligo Pool B (FPB)</th>';
		html += '<th class="dottedleft">Oligo Hybridization for Sequencing Reagent 3 (OHS3)</th>';
		html += '<th class="dottedleft">Stringent Wash 1 (SW1)</th>';
		html += '<th class="dottedleft">Extension Ligation Mix 3 (ELM3)</th>';
		html += '<th class="dottedleft">PCR Master Mix 2 (PMM2)</th>';
		html += '<th class="dottedleft">UB1</th>';
		html += '<th class="dottedleft">TDP</th>';
		html += '<th class="dottedleft">Filterplate</th>';
		html += '<th colspan="12" class="dottedleft">Index 1 Primers Lot Number</th>';
		html += '<th colspan="8" class="dottedleft">Index 2 Primers Lot Number</th>';
		html += '<th class="dottedleft">Expiration date</th>';
		html += '</tr>';
		// Second header row
		html += '<tr>';
		html += '<th></th>';
		html += '<th class="dottedleft"></th>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		// Index 1 Primers Lot Number
		html += '<td class="dottedleft">ATCACGAC</td>';
		html += '<td class="dottedleft">ACAGTGGT</td>';
		html += '<td class="dottedleft">CAGATCCA</td>';
		html += '<td class="dottedleft">ACAAACGG</td>';
		html += '<td class="dottedleft">ACCCAGCA</td>';
		html += '<td class="dottedleft">AACCCCTC</td>';
		html += '<td class="dottedleft">CCCAACCT</td>';
		html += '<td class="dottedleft">CACCACAC</td>';
		html += '<td class="dottedleft">GAAACCCA</td>';
		html += '<td class="dottedleft">TGTGACCA</td>';
		html += '<td class="dottedleft">AGGGTCAA</td>';
		html += '<td class="dottedleft">AGGAGTGG</td>';
		// Index 2 Primers Lot Number
		html += '<td class="dottedleft">TGAACCTT</td>';
		html += '<td class="dottedleft">TGCTAAGT</td>';
		html += '<td class="dottedleft">TGTTCTCT</td>';
		html += '<td class="dottedleft">TAAGACAC</td>';
		html += '<td class="dottedleft">CTAATCGA</td>';
		html += '<td class="dottedleft">CTAGAACA</td>';
		html += '<td class="dottedleft">TAAGTTCC</td>';
		html += '<td class="dottedleft">TAGACCTA</td>';
		html += '</tr>';
		// Third header row
		html += '<tr>';
		html += '<th></th>';
		html += '<th class="dottedleft"></th>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		html += '<td class="dottedleft"></td>';
		// Index 1 Primers Lot Number
		html += '<td class="dottedleft">A701</td>';
		html += '<td class="dottedleft">A702</td>';
		html += '<td class="dottedleft">A703</td>';
		html += '<td class="dottedleft">A704</td>';
		html += '<td class="dottedleft">A705</td>';
		html += '<td class="dottedleft">A706</td>';
		html += '<td class="dottedleft">A707</td>';
		html += '<td class="dottedleft">A708</td>';
		html += '<td class="dottedleft">A709</td>';
		html += '<td class="dottedleft">A710</td>';
		html += '<td class="dottedleft">A711</td>';
		html += '<td class="dottedleft">A712</td>';
		// Index 2 Primers Lot Number
		html += '<td class="dottedleft">A501</td>';
		html += '<td class="dottedleft">A502</td>';
		html += '<td class="dottedleft">A503</td>';
		html += '<td class="dottedleft">A504</td>';
		html += '<td class="dottedleft">A505</td>';
		html += '<td class="dottedleft">A506</td>';
		html += '<td class="dottedleft">A507</td>';
		html += '<td class="dottedleft">A508</td>';
		html += '</tr>';
		html += '</thead>';
		html += '<tbody>';

		// Get JSONArrays with data for kits

		var jsonHeaders = jsonConsumables['Headers'];

		var jsonKitName = jsonConsumables['KitName'];
		var jsonLibraryPrepBox1 = jsonConsumables['LibraryPrepBox1'];
		var jsonIndexKit = jsonConsumables['IndexKit'];
		var jsonContentSetBox3 = jsonConsumables['ContentSetBox3'];
		var jsonOligoPoolA_FPA = jsonConsumables['OligoPoolA_FPA'];
		var jsonOligoPoolB_FPB = jsonConsumables['OligoPoolB_FPB'];
		var jsonOligoHybridizationSequencingReagent3 = jsonConsumables['OligoHybridizationSequencingReagent3'];
		var jsonStringentWash1_SW1 = jsonConsumables['StringentWash1_SW1'];
		var jsonExtensionLigationMix3 = jsonConsumables['ExtensionLigationMix3'];
		var jsonPcrMasterMix2_PMM2 = jsonConsumables['PcrMasterMix2_PMM2'];
		var jsonUB1 = jsonConsumables['UB1'];
		var jsonTDP = jsonConsumables['TDP'];
		var jsonFilterplate = jsonConsumables['Filterplate'];
		
		var jsonIndexPrimerA701 = jsonConsumables['IndexPrimerA701'];
		var jsonIndexPrimerA702 = jsonConsumables['IndexPrimerA702'];
		var jsonIndexPrimerA703 = jsonConsumables['IndexPrimerA703'];
		var jsonIndexPrimerA704 = jsonConsumables['IndexPrimerA704'];
		var jsonIndexPrimerA705 = jsonConsumables['IndexPrimerA705'];
		var jsonIndexPrimerA706 = jsonConsumables['IndexPrimerA706'];
		var jsonIndexPrimerA707 = jsonConsumables['IndexPrimerA707'];
		var jsonIndexPrimerA708 = jsonConsumables['IndexPrimerA708'];
		var jsonIndexPrimerA709 = jsonConsumables['IndexPrimerA709'];
		var jsonIndexPrimerA710 = jsonConsumables['IndexPrimerA710'];
		var jsonIndexPrimerA711 = jsonConsumables['IndexPrimerA711'];
		var jsonIndexPrimerA712 = jsonConsumables['IndexPrimerA712'];
		
		var jsonIndexPrimerA501 = jsonConsumables['IndexPrimerA501'];
		var jsonIndexPrimerA502 = jsonConsumables['IndexPrimerA502'];
		var jsonIndexPrimerA503 = jsonConsumables['IndexPrimerA503'];
		var jsonIndexPrimerA504 = jsonConsumables['IndexPrimerA504'];
		var jsonIndexPrimerA505 = jsonConsumables['IndexPrimerA505'];
		var jsonIndexPrimerA506 = jsonConsumables['IndexPrimerA506'];
		var jsonIndexPrimerA507 = jsonConsumables['IndexPrimerA507'];
		var jsonIndexPrimerA508 = jsonConsumables['IndexPrimerA508'];

		var jsonExpirationDate = jsonConsumables['ExpirationDate'];

		var numItems = jsonKitName.length;

		for (var i = 0; i < numItems; i++)
		{
			html += '<tr class="highlight">';
			html += '<th>' + Strings.encodeTags(jsonKitName[i]) + '</th>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonLibraryPrepBox1[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexKit[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonContentSetBox3[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonOligoPoolA_FPA[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonOligoPoolB_FPB[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonOligoHybridizationSequencingReagent3[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonStringentWash1_SW1[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonExtensionLigationMix3[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonPcrMasterMix2_PMM2[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonUB1[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonTDP[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonFilterplate[i]) + '</td>';

			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA701[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA702[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA703[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA704[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA705[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA706[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA707[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA708[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA709[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA710[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA711[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA712[i]) + '</td>';

			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA501[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA502[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA503[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA504[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA505[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA506[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA507[i]) + '</td>';
			html += '<td class="dottedleft">' + Strings.encodeTags(jsonIndexPrimerA508[i]) + '</td>';

			html += '<td class="dottedleft">' + Strings.encodeTags(jsonExpirationDate[i]) + '</td>';

			html += '</tr>';
		}
		html += '</tbody>';
		html += '</table>';
		Doc.element('detailsSection').innerHTML = html;

		Wizard.setCurrentStep(2);
		Doc.show('gocancel');
		Doc.show('gocreate');
		Doc.show('goregister');
		
		Wizard.keepSessionAlive();
//alert("exreg.initializeStep2(): End consumablesFile = " + consumablesFileName);
	}

	exreg.downloadReagentLotNoFile = function()
	{
		var frm = document.forms['meludi'];
		var file = frm.consumablesFile.files[0];
		var reagentInfo = {};
		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=PrepareDownloadReagentLotNoFile';
		url += '&referenceName='+encodeURIComponent(frm.consumablesFile.value);
		url += '&expirationDate='+encodeURIComponent(frm.expirationDate.value);

		// Reagents
		reagentInfo = jsonConsumables;

		// POST
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, exreg.downloadReagentLotNoFileResults, 'POST', JSON.stringify(reagentInfo));
	}

	exreg.downloadReagentLotNoFileResults = function(response)
	{
		var tmpFilePath = response;
		var frm = document.forms['meludi'];
		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadReagentLotNoFile';
		url += '&referenceName='+encodeURIComponent(frm.consumablesFile.value);
		url += '&expirationDate='+encodeURIComponent(frm.expirationDate.value);
		url += '&tmpFilePath='+encodeURIComponent(tmpFilePath);
		window.open(url);
	}

/*	
	exreg.downloadReagentLotNoFile_Old = function()
	{
		var frm = document.forms['meludi'];
		
		var reagentInfo = {};
		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadReagentLotNoFile';
		url += '&startListName='+encodeURIComponent(frm.startListName.value);
		url += '&isolationDate='+encodeURIComponent(frm.isolationDate.value);
		
		// Reagents
		for (var i = 0; i < exreg.REAGENTS.length; i++)
		{
			var rg = exreg.REAGENTS[i];
			reagentInfo[rg] = frm[rg].value;
		}

		url += '&reagentInfo=' + encodeURIComponent(JSON.stringify(reagentInfo));
		window.open(url);
	}
*/
	
	exreg.validateStep2 = function(event)
	{
		var valid = true;
		valid &= consumablesFileIsValid;
		
//alert("exreg.validateStep2(): valid = " + valid);
		if (!valid) event.preventDefault();
	}

	exreg.submit = function()
	{
		var frm = document.forms['meludi'];
		
		var submitInfo = {};
		submitInfo = jsonConsumables;

		// Library preparation reagent file
		submitInfo.referenceName = frm.consumablesFile.value;
		submitInfo.expirationDate = frm.expirationDate.value;

		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=RegisterKits';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, exreg.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	exreg.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
/*
		Doc.show('gocreate');
*/
	}

	exreg.createProtocol = function()
	{
		var frm = document.forms['meludi'];
		var submitInfo = {};
		submitInfo.items = [];

		submitInfo.docMode = 'report';
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var totNumItems = numItems;
		for (var i = 0; i < totNumItems; i++)
		{
			var item = null;
			item = selItemsList[i];
			submitInfo.items[submitInfo.items.length] = item;
		}

		// Extraction
		submitInfo.startListName = frm.startListName.value;
		submitInfo.isolationDate = frm.isolationDate.value;
		submitInfo.extractionOperator = frm.extractionOperator.value;
		submitInfo.extractionProtocol = parseInt(frm.extractionProtocolId.value, 10);
		var extractionProtocolName = frm.extractionProtocolName.value;
		var protocolVersionNo = '';
		if (extractionProtocolName)
		{
			protocolVersionNo = extractionProtocolName;
			// Remove part of string up to and including last "v"
			var vIndex = protocolVersionNo.indexOf('v');
			while (vIndex >= 0)
			{
				// Remove part of string up to and including first "v"
				protocolVersionNo = protocolVersionNo.substring(vIndex + 1);
				vIndex = protocolVersionNo.indexOf('v');
			}
		}
		var protocolPreviewFlag = null;
		if (trackingProtocolPreview)
		{
			protocolPreviewFlag = 'true';
		}
		submitInfo.extractionProtocolName = extractionProtocolName;
		submitInfo.protocolVersionNo = protocolVersionNo;
		submitInfo.protocolPreviewFlag = protocolPreviewFlag;
		submitInfo.dnaDefaultVolume = ExtractUtils.getNumber(frm.dnaDefaultVolume.value);
		
		// QIAcube
		submitInfo.qiacubeDate = frm.qiacubeDate.value;
		submitInfo.qiacubeOperator = frm.qiacubeOperator.value;
		submitInfo.qiacubeRunNo = parseInt(frm.qiacubeRunNo.value, 10);

		// Specimen reagents
		submitInfo.xyleneSpecimen = frm.xyleneSpecimen.value;
		submitInfo.etoh995Specimen = frm.etoh995Specimen.value;
		submitInfo.allPrepFfpeKit = frm.allPrepFfpeKit.value;
		submitInfo.bufferPkdSpecimen = frm.bufferPkdSpecimen.value;
		submitInfo.bufferAtlSpecimen = frm.bufferAtlSpecimen.value;
		submitInfo.proteinaseKSpecimen = frm.proteinaseKSpecimen.value;
		submitInfo.rnaseASpecimen = frm.rnaseASpecimen.value;

		// QIAcube
		submitInfo.etoh995 = frm.etoh995.value;
		submitInfo.bufferRlt = frm.bufferRlt.value;
		submitInfo.bufferFrn = frm.bufferFrn.value;
		submitInfo.bufferRpe = frm.bufferRpe.value;
		submitInfo.bufferAl = frm.bufferAl.value;
		submitInfo.bufferAw1 = frm.bufferAw1.value;
		submitInfo.bufferAw2 = frm.bufferAw2.value;
		submitInfo.bufferAte = frm.bufferAte.value;
		submitInfo.bufferRdd = frm.bufferRdd.value;
		submitInfo.rnaseFreeWater = frm.rnaseFreeWater.value;
		submitInfo.dnaseMix = frm.dnaseMix.value;
		submitInfo.rneasyMinEluteSpinColumn = frm.rneasyMinEluteSpinColumn.value;
		submitInfo.qiaampMinEluteSpinColumn = frm.qiaampMinEluteSpinColumn.value;

		// Quality control reagents
		submitInfo.kapaSybrFast = frm.kapaSybrFast.value;
		submitInfo.qualityControlPrimersQcpRgt = frm.qualityControlPrimersQcpRgt.value;
		submitInfo.qualityControlTemplateQct = frm.qualityControlTemplateQct.value;
		submitInfo.qubitDnaHighSens = frm.qubitDnaHighSens.value;
		submitInfo.qubitDnaBroadRange = frm.qubitDnaBroadRange.value;

		// Save values in hidden input fields for retrieval after HTML request
		var submitInfoJsonStr = JSON.stringify(submitInfo);
		frm.hiddenSubmitInfo.value = submitInfoJsonStr;
		frm.hiddenNumItems.value = submitInfo.items.length;
		frm.hiddenCounterBalanceInfoRow.value = counterBalanceInfoRow;

		// Calling frm.submit() will change jsp file to extraction_protocol2.jsp
		frm.submit();
	}

	return exreg;
}();

Doc.onLoad(ExtractionReg.initPage);

