<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.meludi");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final Formatter dateFormat = new DateFormatter("yyyyMMdd");
%>
<base:page type="default" >
<base:head 
	scripts="~../meludi-2.js,~add_consumables_lot_number_file.js,~../sampleproc/extraction_utils.js" 
	styles="path.css,~../css/meludi-2.css"
	>
<style>
tr.highlight
{
	border-top-width: 1px;
	border-top-style: dotted;
}

#detailsTable
{
	width: 100%; 
	border-collapse: collapse;
	border-bottom-width: 1px;
	border-top-width: 1px;
}

#detailsTable td, #detailsTable th
{
	text-align: center;
	min-width: 5%;
	padding-top: 1px;
	padding-bottom: 1px;
}

#detailsTable .comment
{
	min-width: 10%;
}

#detailsTable .italic
{
	font-style: italic;
}

.nondefault
{
	background: #FFF066;
}
.nondefault:after
{
	content: '›';
}
.nondefault:before
{
	content: '‹';
}
span.status
{
	width: 20px;
	float: right;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="MeLuDi" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Add consumables lot number file" 
		/></p:path>

	<div class="content">

<!--
	<form name="meludi" action="extraction_protocol2.jsp" method="post" target="_blank" id="wizard" class="wizard">
-->
	<form name="meludi" id="wizard" class="wizard">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="hiddenSubmitInfo" value="">
<!--
		<input type="hidden" name="hiddenNumItems" value="">
		<input type="hidden" name="hiddenCounterBalanceInfoRow" value="">
-->

	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select the consumables lot number file to process</div>
		<div class="step-content">
	
			<div class="bg-filled-50" style="padding: 2px;">
				A "Consumables lot number" file is a text file with rows of tab/comma/semicolon-separated values,<br>
				where each row contains a specification key in first/second column, followed by data columns.<br>
				The file is parsed, assuming known specification keys at the beginning of each row.<br>
				<br>
				The data is then presented in a table with specification keys in a header row, with data<br>
				for each kit on a single row. (Basically, original rows/columns -> columns/rows.)<br>
			</div>

			<table class="step-form">
			<tr class="align-top">
				<td class="prompt">Consumables lot no. file</td>
				<td class="input">
					<input type="file" name="consumablesFile" id="consumablesFile" class="required" style="width: 95%;" accept=".csv,.tsv">
				</td>
				<td class="status" id="consumablesFile.status"></td>
				<td class="help">
					<span id="consumablesFile.message" class="message"></span>
					Select a CSV file containing lot numbers for the reagents.
				</td>
			</tr>
			<tr>
				<td class="prompt">Expiration date</td>
				<td class="input">
					<input type="text" name="expirationDate" id="expirationDate"
						value="<%=dateFormat.format(new Date()) %>" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus=""
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="expirationDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="expirationDate"
							data-date-format="yyyyMMdd"
							data-title="Expiration date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="expirationDate.status"></td>
				<td class="help">
					<span id="expirationDate.message" class="message"></span>
					(YYYYMMDD or MMDD) This date is also used in name of optional file to download
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<!-- 2. Consumables lot number information -->
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">Consumables lot number details</div>
		<div class="step-content">

			<div class="bg-filled-50" id="detailsConsumablesFileName" style="padding: 2px;"></div>

			<div id="detailsSection"></div>

			<table class="step-form">
			<tr>
				<td class="prompt">Download reagent lot no. file</td>
				<td class="input">
					<base:button id="downloadReagentLotNoFile" title="Download..."
						image="<%=home + "/images/download.png"%>" style="width:10em;" />
				</td>
				<td class="status" id="downloadReagentLotNoFile.status"></td>
				<td class="help">
					<span id="downloadReagentLotNoFile.message" class="message"></span>
					Download file with current lot numbers for future import/reference, with one row per kit.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
<!--
		<td><base:button id="gocreate" title="Create library reagents report" image="<%=home+"/images/import.png"%>" /></td>
-->
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>

	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>