var Labelgen = function()
{
	var labelgen = {};
	var debug = 0;
	
	var caseIsValid = true;
	var nofCasesIsValid = true;
	
	// Page initialization
	labelgen.initPage = function()
	{
		previewTitle = Doc.element('previewTitle');
		previewList = Doc.element('previewList');

		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', labelgen.validateStep1);
		Events.addEventHandler('nofCases', 'blur', labelgen.nofCasesOnChange);
		Events.addEventHandler('caseName', 'blur', labelgen.caseNameOnChange);
		Events.addEventHandler('caseName', 'keypress', labelgen.validateStep1);

		// Navigation
		Buttons.addClickHandler('goexport', labelgen.goExport);
		Buttons.addClickHandler('gopreview', labelgen.goPreview);

		var url = '../LabelGeneration.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLastLabelCase';
		Wizard.showLoadingAnimation('Loading cases...');
		Wizard.asyncJsonRequest(url, labelgen.caseInfoLoaded);
	}
	
	labelgen.caseInfoLoaded = function(response)
	{
		var frm = document.forms['meludi'];	

		var nofCases = response.count;
		if (nofCases == null)
		{
			nofCases = 0;
		}
		var startNum = nofCases + 1;
		// Pad number with leading zeros to get 5 digits
		startNum = String('00000' + startNum).slice(-5);
		var startCase = 'ML' + startNum;
		frm.caseName.value = startCase;
		
		Doc.show('step-1');
		Doc.show('gopreview');
		Doc.show('goexport');
	}

	labelgen.goPreview = function()
	{
		labelgen.doExport(true);
	}

	labelgen.goExport = function()
	{
		labelgen.doExport(false);
	}

	labelgen.doExport = function(preview)
	{
		var frm = document.forms['meludi'];
		var nofCases = frm.nofCases.value;
		var nofTubesPerCase = frm.nofTubesPerCase.value;
		var startCase = frm.caseName.value;

		var url = '../LabelGeneration.servlet?ID=' + App.getSessionId();
		url += '&cmd=GetLabelFile&nofCases='+nofCases+'&nofTubesPerCase='+nofTubesPerCase+'&startCase=' + encodeURIComponent(startCase) + '&preview='+preview;
		
		if (preview) 
		{
			Doc.hide('previewWrapper');
			url += '&preview=1';
			
			Wizard.showLoadingAnimation('Working...');
			Doc.hide('navigation');
			Wizard.asyncJsonRequest(url, labelgen.onPreviewLoaded);
		}
		else
		{
			window.location = url;		
		}
	}

	labelgen.onPreviewLoaded = function(response)
	{
		Doc.show('navigation');
		var frm = document.forms['meludi'];
		var allLines = response.split('\n');
		var numLines = allLines.length - 1;
		
		var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
		// Check first column for 'ItemType' string, which indicates a header line.
		var numNoConsent = 0;
		var numMissingConsent = 0;
		for (var i = 1 ; i <= numLines; i++)
		{
			var line = allLines[i];
			var cols = line.split(/\t/);
			var firstColumnVal = cols[0];
			var lineIsHeader = false;
			if (firstColumnVal == 'ItemType')
			{
				lineIsHeader = true;
			}
			var rowClass = '';
			if (lineIsHeader)
			{
				html += '<tr><th>'+line.replace(/\t/g, '</th><th>')+'</th></tr>';
			}
			else
			{
				html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
			}
		}
		
		previewList.innerHTML = '<table>'+html+'</table>';
		Doc.show('previewWrapper');
	}

	labelgen.nofCasesOnChange = function()
	{
		var frm = document.forms['meludi'];
		var nofCases = frm.nofCases.value;
		nofCasesIsValid = false;
		if (nofCases == '')
		{
			Wizard.setInputStatus('nofCases', 'invalid', 'Missing');
			frm.nofCases.focus();
			return;
		}
		// Check that input is a natural number (1, 2, 3, ...)
		var regex = /^[1-9][0-9]*$/;
		if (!nofCases.match(regex))
		{
			Wizard.setInputStatus('nofCases', 'invalid', 'Only numbers > 0 are allowed.');
			frm.nofCases.focus();
			return;
		}
		Wizard.setInputStatus('nofCases', 'valid', '');
		nofCasesIsValid = true;
	}

	labelgen.caseNameOnChange = function()
	{
		var frm = document.forms['meludi'];
		
		var caseName = frm.caseName.value.toUpperCase();
		caseIsValid = false;
		if (caseName == '')
		{
			Wizard.setInputStatus('caseName', 'invalid', 'Missing');
			frm.caseName.focus();
			return;
		}
		if (!Meludi.isValidCaseName(caseName))
		{
			Wizard.setInputStatus('caseName', 'invalid', 'Only "ML" + 5 digits is allowed.');
			frm.caseName.focus();
			return;
		}

		frm.caseName.value = caseName;
		Wizard.setInputStatus('caseName', 'valid');
		caseIsValid = true;
	}

	labelgen.validateStep1 = function(event)
	{
		// Everything should be OK here, this is for future use
		var frm = document.forms['meludi'];
		if (nofCasesIsValid && caseIsValid)
		{
			return;
		}
		event.preventDefault();
	}

	labelgen.addEventHandlers = function(elements, eventName, handler)
	{
		for (var i = 0; i < elements.length; i++)
		{
			Events.addEventHandler(elements[i], eventName, handler);
		}
	}
	
	return labelgen;
}();

Doc.onLoad(Labelgen.initPage);

